Index: run/run.sh
===================================================================
--- run/run.sh	(revision df87f0c5b17c71c88990aa112f6883546821d75d)
+++ run/run.sh	(revision 433d1eb2dfb8124bf1905a6a5ac5183450bd6f9d)
@@ -11,23 +11,22 @@
 # -----------------------------------------------------------------
 # AVAILABLE COMMANDLINE ARGUMENTS TO SET
-#
+# 
 # THE USER HAS TO SPECIFY THESE PARAMETERS:
 
 QUEUE='ecgate'
-START_DATE=20190215
-END_DATE=20190215
+START_DATE=None
+END_DATE=None
 DATE_CHUNK=None
-JOB_CHUNK=1
+JOB_CHUNK=3
 BASETIME=None
 STEP=None
 LEVELIST=None
 AREA=None
-INPUTDIR=''
+INPUTDIR=None
 OUTPUTDIR=None
-FLEXPARTDIR=None 
 PP_ID=None
 JOB_TEMPLATE='job.temp' 
-CONTROLFILE='CONTROL_OD.fastnet' 
-DEBUG=0 
+CONTROLFILE='CONTROL_CERA' 
+DEBUG=1
 REQUEST=2
 PUBLIC=0
@@ -40,5 +39,5 @@
 
 # PATH TO SUBMISSION SCRIPT
-pyscript=../source/python/submit.py
+pyscript=../Source/Python/submit.py
 
 # INITIALIZE EMPTY PARAMETERLIST
@@ -76,7 +75,4 @@
   parameterlist+=" --outputdir=$OUTPUTDIR"
 fi
-if [ -n "$FLEXPARTDIR" ]; then
-  parameterlist+=" --flexpartdir=$FLEXPARTDIR"
-fi
 if [ -n "$PP_ID" ]; then
   parameterlist+=" --ppid=$PP_ID"
Index: n/run_local.sh
===================================================================
--- run/run_local.sh	(revision b02a07e92bd322edac5c617854791e5cc0e14990)
+++ 	(revision )
@@ -1,108 +1,0 @@
-#!/bin/bash
-#
-# @Author: Anne Philipp
-#
-# @Date: October, 4 2018
-#
-# @Description: 
-#
-
-
-# -----------------------------------------------------------------
-# AVAILABLE COMMANDLINE ARGUMENTS TO SET
-#
-# THE USER HAS TO SPECIFY THESE PARAMETER
-#
-
-QUEUE=''
-START_DATE='20090108'
-END_DATE=None
-DATE_CHUNK=None
-JOB_CHUNK=None
-BASETIME=None
-STEP=None
-LEVELIST=None
-AREA=None
-INPUTDIR='./workspace'
-OUTPUTDIR=None
-FLEXPARTDIR=None 
-PP_ID=None
-JOB_TEMPLATE='' 
-CONTROLFILE='CONTROL_CERA.testgrid' 
-DEBUG=1 
-REQUEST=1
-PUBLIC=0
-
-# -----------------------------------------------------------------
-#
-# AFTER THIS LINE THE USER DOES NOT HAVE TO CHANGE ANYTHING !!!
-#
-# -----------------------------------------------------------------
-
-# PATH TO SUBMISSION SCRIPT
-pyscript=../source/python/submit.py
-
-# INITIALIZE EMPTY PARAMETERLIST
-parameterlist=""
-
-# CHECK FOR MORE PARAMETER 
-if [ -n "$START_DATE" ]; then
-  parameterlist+=" --start_date=$START_DATE"
-fi
-if [ -n "$END_DATE" ]; then
-  parameterlist+=" --end_date=$END_DATE"
-fi
-if [ -n "$DATE_CHUNK" ]; then
-  parameterlist+=" --date_chunk=$DATE_CHUNK"
-fi
-if [ -n "$JOB_CHUNK" ]; then
-  parameterlist+=" --job_chunk=$JOB_CHUNK"
-fi
-if [ -n "$BASETIME" ]; then
-  parameterlist+=" --basetime=$BASETIME"
-fi
-if [ -n "$STEP" ]; then
-  parameterlist+=" --step=$STEP"
-fi
-if [ -n "$LEVELIST" ]; then
-  parameterlist+=" --levelist=$LEVELIST"
-fi
-if [ -n "$AREA" ]; then
-  parameterlist+=" --area=$AREA"
-fi
-if [ -n "$INPUTDIR" ]; then
-  parameterlist+=" --inputdir=$INPUTDIR"
-fi
-if [ -n "$OUTPUTDIR" ]; then
-  parameterlist+=" --outputdir=$OUTPUTDIR"
-fi
-if [ -n "$FLEXPARTDIR" ]; then
-  parameterlist+=" --flexpartdir=$FLEXPARTDIR"
-fi
-if [ -n "$PP_ID" ]; then
-  parameterlist+=" --ppid=$PP_ID"
-fi
-if [ -n "$JOB_TEMPLATE" ]; then
-  parameterlist+=" --job_template=$JOB_TEMPLATE"
-fi
-if [ -n "$QUEUE" ]; then
-  parameterlist+=" --queue=$QUEUE"
-fi
-if [ -n "$CONTROLFILE" ]; then
-  parameterlist+=" --controlfile=$CONTROLFILE"
-fi
-if [ -n "$DEBUG" ]; then
-  parameterlist+=" --debug=$DEBUG"
-fi
-if [ -n "$REQUEST" ]; then
-  parameterlist+=" --request=$REQUEST"
-fi
-if [ -n "$PUBLIC" ]; then
-  parameterlist+=" --public=$PUBLIC"
-fi
-
-# -----------------------------------------------------------------
-# CALL SCRIPT WITH DETERMINED COMMANDLINE ARGUMENTS
-
-$pyscript $parameterlist
-
Index: setup.sh
===================================================================
--- setup.sh	(revision 83b8e3c33a8170fa7ee8b0e007f2c2193bdf4f4f)
+++ setup.sh	(revision 433d1eb2dfb8124bf1905a6a5ac5183450bd6f9d)
@@ -6,10 +6,14 @@
 #
 # @Description: 
+#    This file defines the flex_extract's available installation
+#    parameters and puts them together for the call of the actual 
+#    python installation script. 
+#    It also does some checks to guarantees necessary parameters 
+#    were set.
 #
-
 # -----------------------------------------------------------------
 # AVAILABLE COMMANDLINE ARGUMENTS TO SET
 #
-# THE USER HAS TO SPECIFY THESE PARAMETER
+# THE USER HAS TO SPECIFY THESE PARAMETERS
 #
 TARGET='ecgate'
@@ -19,7 +23,7 @@
 GATEWAY='srvx8.img.univie.ac.at'
 DESTINATION='annep@genericSftp'
-FLEXPARTDIR=""
-JOB_TEMPLATE="job.template"
-CONTROLFILE="CONTROL_EA5.testgrid"
+INSTALLDIR=None
+JOB_TEMPLATE=''
+CONTROLFILE='CONTROL_EA5'
 # -----------------------------------------------------------------
 #
@@ -29,5 +33,5 @@
 
 # PATH TO INSTALLATION SCRIPT
-script="source/python/install.py"
+script="Source/Python/install.py"
 
 # INITIALIZE EMPTY PARAMETERLIST
@@ -72,6 +76,2 @@
 $script $parameterlist
 
-# -----------------------------------------------------------------
-# CALL INSTALLATION TESTS
-
-# TODO !!!!